#!/bin/sh



. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh


#if [ "x$1" = "xweboutput" ]; then
#  APPEND="<BR>"
#fi


if [ "x${IMAP_DAILY}" = "xon" -o "x$1" = "xnow" -o -t 0 ]; then

echo "starting ..." | logger -t "copfilter bayes training"


if [ "x${IMAP_ENABLE}" = "xon" -a "x${IMAP_SERVER}" != "x" -a '"x${IMAP_USER}"' != "x" -a "x${IMAP_PASS}" != "x" ]; then
    echo "IMAP enabled" | logger -t "copfilter bayes training"
    grep "use_bayes 1" $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf &>/dev/null
    if [ "x$?" != "x0" ];then
        echo "enabling use_bayes 1 in local.cf and restarting spamd" | logger -t "copfilter bayes training"
        cp -p $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf /tmp/local.cf.tmp.$$
        cat $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf |  \
        sed -e 's/.*use_bayes.*/use_bayes 1/' > /tmp/local.cf.tmp.$$
        mv  /tmp/local.cf.tmp.$$ $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf
    fi


    TMP_FILE4=$TMPDIR/imap.tmp4
    TMP_FILE5=$TMPDIR/imap.tmp5

    echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-" > $TMP_FILE4
    echo >> $TMP_FILE4
    echo "$CP_imap_mail" >> $TMP_FILE4
    echo >> $TMP_FILE4
    echo >> $TMP_FILE4

    if [ "x${IMAP_DEBUG}" = "xon" ]; then
        IMAP_DEBUG2=1
    else
        IMAP_DEBUG2=0
    fi

    if [ "x${IMAP_SSL}" = "xon" ]; then
        IMAP_SSL=1
    else
        IMAP_SSL=0
    fi

    ##############################
    #Folder settings
    cp -p $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl.tmp.$$
#    cat $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl |sed -e "s/my \$directory =.*/my \$directory = '$IMAP_SPAM_DIR';/"  \
#                          -e "s/^my \$dirAmp =.*/my \$dirAmp = '$IMAP_DIR_AMP';/" \
#                          -e "s/^my \$spamFolder =.*/my \$spamFolder = '$IMAP_SPAM_FOLDER';/"     \
#                          -e "s/^my \$noSpamFolder =.*/my \$noSpamFolder = '$IMAP_NO_SPAM_FOLDER';/"      > $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl.tmp.$$
    cat $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl |\
                          sed -e "s%^my \$spamfolder =.*%my \$spamfolder = '${IMAP_SPAM_FOLDER}';%"  \
                              -e "s%^my \$nospamfolder =.*%my \$nospamfolder = '${IMAP_NO_SPAM_FOLDER}';%"      > $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl.tmp.$$
    mv $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl.tmp.$$ $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl
    echo "done folder settings"
   
    #############################
    #Server settings
    #echo "'zuerst $IMAP_USER'"
    #IUSER=$(echo "$IMAP_USER" | sed -e 's#\\#\/\#g')
    #echo "'$IUSER'"
    cp -p $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl.tmp.$$
    cat $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl |sed -e "s/^Server =.*/Server => '${IMAP_SERVER}',/"    \
                              -e "s,^User =.*,User => "\"$IMAP_USER"\"\,,"      \
                              -e "s/^Password =.*/Password => '$IMAP_PASS',/"      \
                              -e "s/^Debug =.*/Debug => '$IMAP_DEBUG2',/"      \
                              -e "s/^Ssl =.*/Ssl => '$IMAP_SSL',/"    > $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl.tmp.$$
    mv $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl.tmp.$$ $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl
    echo "done server settings"
exit

    if [ -t 0 ]; then
       perl $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl                      | tee $TMP_FILE5
       echo >> $TMP_FILE4
       echo "restaring spamd" >> $TMP_FILE5
       $BASEDIR/opt/mail-spamassassin/etc/init.d/copfilter_spamd restart | tee -a $TMP_FILE5
       echo >> $TMP_FILE4
       echo "Current Status" >> $TMP_FILE4
       echo >> $TMP_FILE4
       $BASEDIR/opt/mail-spamassassin/default/bin/sa-learn --dump magic  | tee -a $TMP_FILE4
    else
       echo >> $TMP_FILE5
       echo "$CP_imap_mail2" > $TMP_FILE5
       perl $BASEDIR/opt/tools/bin/DMZS-sa-learn.pl                  2>&1    | grep -v "dbg: config: read file" |grep -v "dbg: rules:" |grep -v "dbg: plugin:" | tee -a $TMP_FILE5 | logger -t "copfilter bayes training"
       echo >> $TMP_FILE5
       echo "$CP_imap_mail3" >> $TMP_FILE5
       $BASEDIR/opt/mail-spamassassin/etc/init.d/copfilter_spamd restart | tee -a $TMP_FILE5 | logger -t "copfilter bayes training"
       echo >> $TMP_FILE4
       echo "$CP_imap_mail4" >> $TMP_FILE4
       echo "$CP_imap_mail5" >> $TMP_FILE4
       $BASEDIR/opt/mail-spamassassin/default/bin/sa-learn --dump magic  | tee -a $TMP_FILE4 | logger -t "copfilter bayes training"
    fi


    #cat  $TMP_FILE4 |logger -t  "copfilter bayes training"
    echo >> $TMP_FILE4
    cat  $TMP_FILE5 >> $TMP_FILE4


    if [ "x${SMTP_HOST}" = "x" -o "x${EMAIL_ADR}" = "x" ] ; then
         echo "no email notification will be sent, since SMTP_HOST and/or EMAIL_ADR where not yet specified" | logger -t "copfilter bayes training"
    else
         echo "email notification will be sent" | logger -t "copfilter bayes training"

         if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
                 echo "smtp authentication enabled, using user: $SMTP_AUTH_USER"
                 cat $TMP_FILE4 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                                 -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                 -u "[Copfilter] IMAP Bayes Update" |logger -t "sendemail bayes training"
         else
                 cat $TMP_FILE4 | $SENDEMAIL -f $SENDER_ADR -t $EMAIL_ADR -s "${SMTP_HOST}"  \
                                 -u "[Copfilter] IMAP Bayes Update" |logger -t "sendemail bayes training"

         fi
    fi


    chown -R spam.copfilter $BASEDIR/opt/mail-spamassassin/var
    chmod -R a+rX $BASEDIR/opt/mail-spamassassin/var
    

    #cleanup
    rm -f $TMP_FILE4
    rm -f $TMP_FILE5

else
    echo "IMAP disabled, or IMAP_SERVER IMAP_USER IMAP_PASS contain no values" | logger -t "copfilter bayes training"
    cp -p $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf /tmp/local.cf.tmp.$$
    cat $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf |  \
    sed -e 's/.*use_bayes.*/use_bayes 0/' > /tmp/local.cf.tmp.$$
    mv  /tmp/local.cf.tmp.$$ $BASEDIR/opt/mail-spamassassin/etc/mail/spamassassin/local.cf
fi

echo "done" | logger -t "copfilter bayes training"
fi
